#!/u/sirsi/Unicorn/Bin/perl

#system("date");

if (-e "appended.CXREF")
  {
  system("rm appended.CXREF");
  }

@filelist = `ls R*CXREF`;

foreach $filename (@filelist)
  {
  chomp($filename);
  system("cat $filename >> appended.CXREF");
  #print "$filename\n";
  system("mv $filename Downloads");
  }

open(KEYS,"appended.CXREF") || die "No Downloads or no appended.CXREF: $!\n";

$recs = `wc -l appended.CXREF`;
chomp($recs);
$recs =~ s/appended.CXREF//;
$recs =~ s/ //g;
print "The total number of records sent from OCLC is $recs\n";

open(DATA,">data");

while($line=<KEYS>)
  {
  chomp($line);
  ($catkey,$oclc) = split(/\t/,$line);

  $catkey =~ s/^u//;
  $oclc =~ s/ //g;
  $len = length($oclc);

  if ($len < 8)
    {
    $pad = 8 - $len;
    $padOclc = $oclc;
    for($i=0; $i < $pad; $i++)
      {
      $padOclc = "0$padOclc";
      }
    $prefixOclc = "ocm$padOclc";
    }
  elsif ($len == 8)
    {
    $prefixOclc = "ocm$oclc";
    }
  elsif ($len > 8)
    {
    $prefixOclc = "ocn$oclc";
    }
  else
    {
    print FAIL "failed - $line\n";
    }
  print DATA "$catkey|$prefixOclc|\n"; 
  }
close(DATA);

@data035 = `cat data | selcatalog -e035 -iC -oCSe 2>/dev/null`;

open(CAT,">catkeys");
open(OF,">overflow");
open(GOOD,">alreadyDone");
open(ADD035,">add035");
$count = 0;
foreach $line (@data035)
  {
  ($catkey2,$oc,$tag035) = split(/\|/,$line);
  if ($oc eq $tag035)
    {
    print GOOD "$line"; 
    }
  else
    {
    $count++;
    if ($count > 20000)
      {
      print OF "$catkey2\n";
      }
    else
      {
      print CAT "$catkey2\n";

      print ADD035 "*** DOCUMENT BOUNDARY ***\n";
      print ADD035 "FORM=MARC\n";
      print ADD035 ".035.  |a$oc\n";
      print ADD035 ".1003. |a$catkey2\n";
      }
    }
  } 
close(CAT);
close(ADD035);

$dt = `date '+%m%d%H%M'`;
chomp($dt);

if ($count > 20000)
  {
  print "Too many catkeys, $count, 20,000 sent to Adutext - the rest saved as catkeys.$dt\n";
  system("cp overflow catkeys.$dt");
  system("echo 'ALERT - Too many catkeys' >alert.txt");
  }
else
  {
  print "Sending $count catkeys to touchkeys\n";
  }

system("cat catkeys | touchkeys 2>touchkeys.log");

system("cat add035 |catalogmerge -aMARC -bc -if -t035 -r -d >merge.keys 2>merge.log");
system("grep -v **Entry merge.log |translate >mergeTrans.log");
print "\n";
system("cat mergeTrans.log");
print "\n";
open(MER,"mergeTrans.log");
system("touch send2sharonYES");
while (<MER>)
  {
  chomp;
  if ($_ =~ / 0 catalog record/ && $_ =~ /in error/)
    {
    system("rm send2sharonYES");
    last;
    }
  }
system("date");
